package com.mudu.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;


/**
 * @author dong
 * @since 2024/3/12 14:18
 */
@Data
@ApiModel("定时任务实体类")
public class ACheckQuatzEntity {

    /**
     * 工单id
     */
    @ApiModelProperty(value = "归属地")
    private String locationName;

    /**
     * 企业名称
     */
    @ApiModelProperty(value = "企业名称")
    private String enterpriseName;


    /**
     * 整改是否完成(-2专家拒绝,-1是需要专家复查未完成,0未成,1全部完成)
     */
    @ApiModelProperty(value = "整改是否完成(-2专家拒绝,-1是需要专家复查未完成,0未成,1全部完成)")
    private String isFinal;

    /**
     * 创建时间
     */
    @ApiModelProperty("上报时间(如果巡查一起提交,获取巡查的巡查日期")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime ReportDateTime;


    /**
     * 上报人
     */
    @ApiModelProperty(value = "上报人")
    private String ReportPersonName;

    /**
     * 隐患内容
     */
    @ApiModelProperty(value = "隐患内容")
    private String Description;


    /**
     * 现场图片
     */
    @ApiModelProperty(value = "现场图片")
    private String RelativePath;




}
