package com.mudu.entity.dto.request;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;


/**
 * @author dong
 * @since 2024/3/12 14:18
 */
@Data
@ApiModel("定时任务请求类")
public class ACheckQuatzRequest {



    /**
     * 归属地
     */
    @ApiModelProperty(value = "归属地")
    private String locationName;


    /**
     * 企业编号
     */
    @ApiModelProperty(value = "企业编号")
    private String enterpriseID;

    /**
     * 人员编号
     */
    @ApiModelProperty(value = "人员编号")
    private String rybh;

    /**
     * 整改是否完成(-2专家拒绝,-1是需要专家复查未完成,0未成,1全部完成)
     */
    @ApiModelProperty(value = "整改是否完成(-2专家拒绝,-1是需要专家复查未完成,0未成,1全部完成)")
    private String isFinal;

    /**
     * 创建时间
     */
    @ApiModelProperty("上报时间(如果巡查一起提交,获取巡查的巡查日期")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date reportDateTime;



    /**
     * 隐患内容
     */
    @ApiModelProperty(value = "隐患内容")
    private String description;


    /**
     * 现场图片
     */
    @ApiModelProperty(value = "现场图片")
    private String relativePath;

    /**
     * 风险点id
     */
    @ApiModelProperty(value = "风险点id")
    private String checkId;


    /**
     * 整改完成日期
     */
    @ApiModelProperty("整改完成日期")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date FinalDateTime;

    /**
     * 整改要求完成日期
     */
    @ApiModelProperty("整改要求完成日期")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date NeedFinalDateTime;

}
